// #name	= FlagTimer
// #version 	= 1.3
// #date 	= 2001-09-20
// #author 	= Runar
// #email 	= runar@vsdn.org
// #web 	= http://www.vsdn.org
// #description	= Flag field timer
// #credits	= Da_Timsta, my beta-tester :)
// #status 	= Release 3

// exec("scripts/autoexec/flagtimer.cs");

// Object definition
if(!isObject(FlagTimer))
{
	new ScriptObject(FlagTimer)
	{
		class = FlagTimer;

	};
}

// The function that starts the timer
function FlagTimer::Start(%this, %flagId)
{
	objectiveHud.flagLocation[%flagId].setValue("<In the Field: 45>");

	%this.DropTime[%flagId] = getSimTime();
	%this.Dropped[%flagId] = 1;

	%this.ScheduledId[%flagId] = %this.schedule(500, Count, %flagId);
}

// The function that does the time calculation
function FlagTimer::Count(%this, %flagId)
{
	if(%this.Dropped[%flagId])
	{
		objectiveHud.flagLocation[%flagId].setValue("<In the Field: "@ 45-mFloor((getSimTime() - %this.DropTime[%flagId])/1000) @">");
		%this.ScheduledId[%flagId] = %this.Schedule(500, Count, %flagId);
	}
}

// Reset
function FlagTimer::Reset(%this)
{
	for(%i = 0; %i < 5; %i++)
	{
		if(%this.Dropped[%i])
		{
			cancel(%this.ScheduledId[%i]);
			%this.Dropped[%i] = false;
			%this.DropTime[%i] = "";
		}
	}
}

function resetFlagTimer()
{
	FlagTimer.Reset();
}

// Package with parented functions
package FlagTimerPkg
{
	// Parented CTF functions from objectiveHud.cs
	function ctfFlagTaken(%msgType, %msgString, %a1, %a2, %a3, %a4, %a5, %a6)
	{
		FlagTimer.Dropped[detag(%a3)] = false;

		parent::ctfFlagTaken(%msgType, %msgString, %a1, %a2, %a3, %a4, %a5, %a6);
	}	   

	function ctfFlagDropped(%msgType, %msgString, %a1, %a2, %a3, %a4, %a5, %a6)
	{
		FlagTimer.Start(detag(%a3));

		parent::ctfFlagDropped(%msgType, %msgString, %a1, %a2, %a3, %a4, %a5, %a6);
	}

	function ctfFlagReturned(%msgType, %msgString, %a1, %a2, %a3, %a4, %a5, %a6)
	{
		Flagtimer.Dropped[detag(%a3)] = false;

		parent::ctfFlagReturned(%msgType, %msgString, %a1, %a2, %a3, %a4, %a5, %a6);
	}

	function DispatchLaunchMode()
	{
		addMessageCallback('MsgClearObjHud', resetFlagTimer);

		parent::DispatchLaunchMode();
	}
};

// Activate the package
activatePackage(FlagTimerPkg);
